#-----------------------------------------------------------------------------
# Unbend a MT.
# Sep 10, 2006
# Copyright (c) 2006 by David G. Drumright (ockham)
# You start with the figure and the MT you already produced for the
# bent joint.  Have the joint bent in the position you want.
#-----------------------------------------------------------------------------

MTname="xxxbendxxx"

import poser
scene = poser.Scene()
XR=poser.kParmCodeXROT
YR=poser.kParmCodeYROT
ZR=poser.kParmCodeZROT

global F,A
F=scene.CurrentFigure()
A=None
A=scene.CurrentActor()

P=A.Parameter(MTname)

# Take the selected part.  Find the nonzero MT values:
MTvalid={}
G = A.Geometry()
for i in range(G.NumVertices()):
    Vq=None
    try:
        Vq=P.MorphTargetDelta(i)
    except:
        pass
    if Vq and (Vq != 0.0):
        MTvalid[i]=Vq

# Now look at those verts only, and get a diff for each.
Pos0={}
Pos1={}
Diff={}

# Assume the current position of joint is the desired end pos.
Px=A.ParameterByCode(XR)
Py=A.ParameterByCode(YR)
Pz=A.ParameterByCode(ZR)
X1=Px.Value()
Y1=Py.Value()
Z1=Pz.Value()

# Get end pos values of the verts.
scene.DrawAll()
for i in MTvalid.keys():
    WV=G.WorldVertex(i)
    Pos1[i]=( (WV.X(),WV.Y(),WV.Z()) )

# Now force zero
Px.SetValue(0.0)
Py.SetValue(0.0)
Pz.SetValue(0.0)
# Get zero pos values of the verts
scene.DrawAll()
for i in MTvalid.keys():
    WV=G.WorldVertex(i)
    Pos0[i]=( (WV.X(),WV.Y(),WV.Z()) )

# Now apply the diffs to the MTs.
for i in MTvalid.keys():
    (Xm,Ym,Zm)=MTvalid[i]
    (X0,Y0,Z0)=Pos0[i]
    (X1,Y1,Z1)=Pos1[i]
    Xnew = Xm - (X1-X0)
    Ynew = Ym - (Y1-Y0)
    Znew = Zm - (Z1-Z0)
    P.SetMorphTargetDelta(i,Xnew,Ynew,Znew)

print ("done")

#-----------------------------------------------------------------------------
